0103abc
0103abc 的网站
= 算法、题解与学习记录 =
文章列表
$a+b\le n$ 是简单的,两个操作互不影响,因此答案只能为 $0,1,2,-1$ 中的一个,简单讨论即可。 剩下 $a+b>n$,先特判掉 $<2$ 次操作可以排序的情况。注意到连续多次执行同一个操作肯定不优,而交替执行操作就是利用中...
upd 05/13/2026:修改了若干笔误。 $O(2^nn^2)$ 直接状压 dp 即可。 $O(n^4)$ 这个看着就不太好计数,因此做一个经典(此处存疑)的转化: 钦定集合 $S$ 内所有位都为上升位,则可以看作这个集合内所有位置对答案的贡献为...
APIO 讲课例题。 独立集比较难找,考虑先处理更好找的简单环。注意到求出图的任意一棵生成树后,若图中存在一个 $v\to u$ 的返祖边,则 $u$ 到 $v$ 存在一个包含 $|depu-depv|+1$ 个点的简单环,其中 $depi$ 表示 $i$ 点在找到的 DFS...
根据期望的线性性考虑拆贡献算答案,容易发现可以合成一段球的部分一定是一个连续的区间,因此考虑记 $f{i,j}$ 表示 $[i,j]$ 编号内的小球恰好合并成一个球的概率,则最终答案就是 $\sum\limits{i=1}^n\sum\li...
容易想到先求出 $lim_i$ 表示 $i$ 位置最大可以填多少,离线然后线段树区间覆盖即可做到单 $\log$。此时把所有位置分为两类: $i$ 位置没有限制条件,则这个位置填 $0\sim h-1$ 这 $h$ 个数都不会对答案造成影响,在最后单独处理即可。 $i$...
考虑先构造一些特殊情况。 树的情况是简单的,直接用 Prufer 序列构造即可。 所有结点的度数都是 $2$ 也是简单的,直接构造一个简单环即可。 考虑更一般的情况。容易发现若所有点度数的和为奇数则必然无解,后面记这个度数的和为 $\text{sum\deg}$。然后考虑计算仙人掌相比树结构多的边数...
注意到平均值在 $n\equiv 1\pmod 2$ 时是整数,$n\equiv 0\pmod 2$ 时是小数,因此容易想到利用这点性质进行分类讨论: $n\equiv 0\pmod 2$ 此时平均值一定形如 $X+0.5$ 的形式。此时若一个值出现了奇数次,则其平均数一定不能被表示为...
或许可以看作是一类可以迁移运用的构造(?)题套路? 核心思想就是多次加强 / 削弱 / 扩展题目中给出的操作,得到性质更好 / 更容易利用 / 更简洁的新操作,通过新操作解决整个问题。 Example 1 给定一个长度为 $n$ 的整数数组 $a$ 和一个包含 $m$ 个正整数的集合 $B$,其中...
简单题。先考虑一个朴素的多项式时间复杂度做法。记 $f{i,j}$ 表示当前确定了要猜的数范围在 $[i,j]$ 中,最少需要花费多少代价可以确定。转移直接枚举猜测的数 $k\in[i,j]\in\mathbb{N+}$ 然后将左右两段区间看作子任务递归处理即可,时间复杂度为 $O(n^3)$。...
建议降绿。把 $Ai$ 按照十进制拆成 $6$ 位,记这 $6$ 位分别为 $(v{i,0},v{i,1},v{i,2},v{i,3},v{i,4},v{i,5})$,则 $Ai+Aj$ 不会触发进位的充要条件就是 $\forall k\i...